//$Id:$
//Ember.TEMPLATES.Dashboard = Ember.Handlebars.compile(document.querySelector("#Dashboard").innerHTML); //No I18N

App = Ember.Application.create();

/* Router Mappings */
App.Router.map(function() {
    this.resource('Search',function(){//No I18N
        this.route('View');//No I18N
    });
    this.resource('Dashboard',function(){//No I18N
        this.route('All');//No I18N
        this.route('GetStart');//NO I18N
        this.route('Issuer',{path:"/issuer/:issuer"});//NO I18N
        this.resource('resources',function(){//No I18N
            this.route('ssh');//No I18N
            this.route('ssl');//No I18N
            this.route('both');//No I18N
        });
        this.route('resourceusers',{path: "/resusers/:type"});//No I18N
        this.resource("Dashboard.Graph",{path: "/Graph/:type/:data"}, function(){});//No I18N
        this.route('KeyRotationGraph',{path: "/keyrotate/:type"});//No I18N
        this.route('VulnerabilitiesGraph',{path: "/vulnerabilities/:type"});//No I18N
        this.route('Expired');//No I18N
        });
      
    this.resource("Inventory", function(){//No I18N
        this.resource("Inventory.Tab", {path: "Tab"},function(){//No I18N
            this.route('Resources'); //No I18N
            this.route('SSH'); //No I18N
            this.route('SSL'); //No I18N
        });
        this.route('SansDetails',{path: "SansDetails/:id"}); //No I18N
        this.route('ResUsersList',{path: "ResUsersList/:res_Id"});//No I18N
        
        this.resource("Inventory.Details",{path: "DetailedView/:res_id/:res_type"}, function(){//No I18N
            this.route('SSL');	//No I18N
            this.route('SSH');	//No I18N
        });
    });
    
     this.resource('Discovery',function(){  //No I18N	33	    this.resource('Discovery'); //No I18N
	        this.route('SSH');//No I18N
            this.route('SSL');//No I18N
            this.route('AD');//No I18N
            this.route('ADUserCert');//No I18N
	        this.route('All');//No I18N	
                this.route('MSLocalCA');//No I18N
                this.route('certStore');//No I18N
                this.route('Agent'); //No I18N
				this.route('AgentsList'); //No I18N
                this.route('AWS'); //No I18N
                this.route('Azure'); //No I18N
                this.route('AWSCredentials');//No I18N
                this.route('AWSCredentialsAddEdit');//No I18N
            this.route("SMTP");//NO I18N
            this.route("Linux");//NO I18N
            this.route("WindowsPath");//NO I18N
            this.route("MDM");//NO I18N
            this.route("EncryptedCertificates",{path:"Discovery/EncryptedCertificates/:os"});//NO I18N
	        this.route('AuditDiscovery');  //No I18N		
	        this.route('DetailedAuditDiscovery',{path: "DetailedAuditDiscovery/:discoveryAudit_id"});  //No I18N		
	    });
    this.resource("SSLMgmt",function(){//NO I18N
        this.route("SSL");//NO I18N
        this.route("MDM");//NO I18N
        this.route('MDMDeploymentAudit');//NO I18N
        this.route("SSLCertificatesGroup");//NO I18N
        this.route("KMPAgents");//No I18N
        this.route("AgentOperationHistory",{path:"AgentOperHistory/:type/:agentId"});//No I18N
        this.route("AgentCertificates");//No I18N
        this.route("RootCertificate");//NO I18N
        this.route("SignedCertificate",{path: "SignedCertificate/:root_id"});//NO I18N
        this.route("CGCertificatesList",{path:"certificatesList/:dgid"});//NO I18N
        this.route("AddCertificateGroup",{path: "AddCertificateGroup/:dgid"}); //No I18N
        this.route("CertificateHistory",{path: "History/:cert_id"});//NO I18N
        this.route("AddCert");//NO I18N
        this.route('CreateCertificate'); //No I18N
        this.route('SSLTemplates'); //No I18N
        this.route('CreateCsr'); //No I18N
        this.route('CreateCertificateList'); //No I18N
        this.route('LetsEncryptRequestList',{path: "ACMERequestList/:acmeServerId"});//NO I18N
        this.route('LetsEncryptRequestHistory',{path:"ACMEHistory/:req_id"});//NO I18N
        this.route('LetsEncryptRequest',{path: "ACMERequest/:acmeServerId"});//NO I18N
        this.route('LetsEncryptChallenges',{path:"ACMEChallenges/:req_id"});//NO I18N
        this.route('CertDetails',{path: "certdetails/:cert_id"}); //No I18N
        this.route('Certificate',{path: "sslcertificate/:cert_id"});//No I18N
        this.route('GoDaddy',{path:"godaddy"});//NO I18N
        this.route('GoDaddyOrder',{path:"godaddyOrder"});//NO I18N        
        this.route('SSLStoreOrder',{path:"sslstoreorder"});//NO I18N
        this.route('GoDaddyOrderDetails',{path:"godaddyOrderDetails/:id"});//NO I18N
        this.route('SSLStoreOrderDetails',{path:"sslStoreOrderDetails/:id"});//NO I18N
        this.route('GoDaddyHistory',{path:"godaddyHistory/:id"});//NO I18N
        this.route('SSLStore',{path:"sslstore/:id"});//NO I18N
        this.route('SSLStoreReissue',{path:"sslstorereissue/:id"});//NO I18N
        this.route('SSLStoreRenew',{path:"sslstorerenew/:id"});//NO I18N
        this.route('DigiCert',{path:"digicert"});//NO I18N
        this.route('DigiCertOrder',{path:"digicertorder"});//NO I18N
        this.route('DigiCertOrderRenew',{path:"digicertRenew/:id"});//NO I18N
        this.route('DigiCertOrderDetails',{path:"digicertOrderDetails/:id"});//NO I18N
        this.route("DigiCertOrder",{path:"digicertorder"});//NO I18N
        this.route('DigiCertOrderDetails',{path:"digiCertOrderDetails/:id"});//NO I18N
        this.route('DigiCertReissue',{path:"digicertReissue/:id"});//NO I18N
        this.route('GlobalSign',{path:"globalsign"});//NO I18N
        this.route('GlobalSignOrder',{path:"globalsignorder"});//NO I18N
        this.route('GlobalSignRenewal',{path:"globalsignrenewal/:id"});//NO I18N
        this.route('GlobalSignOrderDetails',{path:"gsorderDetails/:id"});//NO I18N
        this.route('GlobalSignReissue',{path:"globaslsignReissue/:id"});//NO I18N
        this.route('AWS');//No I18N
        this.route('RequestAWSCertificate'); //No I18N
        this.route('RequestPrivateAWSCertificate'); //No I18N
        this.route('RequestAWSPrivateCert'); //No I18N
        this.route('Orderstatus'); //No I18N
        this.route('Azure'); //No I18N
        this.route('RequestAzureCertificate'); //No I18N
        this.route('AzureCertificateRequests'); //No I18N
	this.route('Sectigo',{path:"sectigo"});//NO I18N
        this.route('SectigoOrder',{path:"sectigoorder"});//NO I18N
        this.route('SectigoOrderDetails',{path:"sectigoOrderDetails/:id"});//NO I18N
    this.resource("Request",function(){ //No I18N
        this.route('List'); //No I18N
        this.route('Open'); //No I18N
        this.route('Edit',{path: "Edit/:req_id"}); //No I18N
        this.route('Closed',{path: "Closed/:req_id"}); //No I18N
    });
        this.route('Vulnerablities',{path:"vulnerabilities/:cert_id"});//NO I18N
    this.route('DeployedServers',{path:"deployedsevers/:cert_id"});//NO I18N
        this.route("MSCA");//NO I18N
        this.route("MSCACertRequest");//NO I18N
       
       });
    this.resource("GlobalSignMgmt",function(){//NO I18N
        this.route("GlobalSignAccount");//NO I18N
        this.route("DNSProvider");//NO I18N
        this.route("Deploy");//NO I18N
        this.route("WAgents");//NO I18N
    });
    this.resource("LETSMgmt",function(){//NO I18N
        this.route("LETSAccount",{path:"ACMEAccount/:acmeServerId"});//NO I18N
        this.route("LETSDeploy",{path:"ACMEDeploy"});//NO I18N
        this.route("DNSProvider");//NO I18N
        this.route("WAgents");//NO I18N
        this.route("LETSDeployFilter",{path:"ACMEDeployFilter/:domain"});//NO I18N
        this.route('AddNewAccount',{path:"addNewAccount/:acmeServerId"});//NO I18N
        this.route('NewRegistration',{path:"newRegistration/:acmeServerId"});//NO I18N
    });  
    this.resource("SSLStoreMgmt",function(){//NO I18N
        this.route("SSLStoreAccount");//NO I18N
        this.route("DNSProvider");//NO I18N
        this.route("OrganizationDetails");//NO I18N
        this.route("Deploy");//NO I18N
        this.route("WAgents");//NO I18N
    });
    this.resource("DigiCertMgmt",function(){//NO I18N
        this.route("DigiCertAccount");//NO I18N
        this.route("DigiCertProducts");//NO I18N        
        this.route("DigiCertOrganizations");//NO I18N
        this.route("DigiCertDomains");//NO I18N
        this.route("Deploy");//NO I18N
        this.route("WAgents");//NO I18N
    });
    this.resource("SectigoMgmt",function(){//NO I18N        
        this.route("SectigoAccount");//NO I18N
        this.route("SectigoOrganizations");//NO I18N        
        this.route("SectigoDomains");//NO I18N
        this.route("SectigoProfiles");//NO I18N
    });
    this.resource("AWSMgmt",function(){//NO I18N
        this.route("AWSCredential");//NO I18N
        this.route("AWSPrivateCA");//NO I18N        
        this.route("AWSDomain");//NO I18N
        this.route("DNSProviderAWS");//No I18N
    });
    this.resource("AzureMgmt",function(){//NO I18N
        this.route("AzureCredential");//NO I18N
        this.route("AzureKeyVault");//NO I18N
        this.route("AzureIssuer");//NO I18N
    });

    this.resource("SSHMgmt",function(){//NO I18N
           this.route('SSH'); //No I18N
           this.route("Details",{path: "DetailedView/:res_id/:res_type"});//No I18N
           this.route("ResourceGroup", {path: "resourceGroup"});//No I18N
           this.route('AddResourceGroup',{path: "addResourceGroup/:dgid"}); //No I18N
           this.route('ResourceList',{path: "resourceList/:rgid"}); //No I18N
           this.route("Keys");//NO I18N
           this.route("KeysGroup",{path: "keysGroup"});//NO I18N
           this.route("UsersGroup",{path: "usersGroup"});//NO I18N
           this.route("AllUsers");//NO I18N
           this.route("UsersGroup",{path: "usersGroup"});//NO I18N
           this.route("UsersGroupUsers",{path: "usersGroupUsers/:ugid"});//No I18N
           this.route('DiscoveredKeys',{path: "discoveredKeys"}); //No I18N
           this.route("CreateSSHKey");//NO I18N
           this.route("KeyRotationAudit",{path:"KeyRotationAudit/:keyStateId"});//NO I18N
           this.route("DetailedKeyRotationAudit",{path:"DetailedKeyRotationAudit/:keyRotationAuditId"});//No I18N
           this.route("UpdatePrivateKeyAssociation",{path: "UpdateKeyView/:key_id"});//NO I18N
           this.route("ShowAssociateMapper",{path: "ShowAssociateMapper/:key_id"}); //No I18N
           this.resource("SSHMgmt.MappingGraph",{path: "mappingGraph/:type/:id"},function(){}); //No I18N
	   this.route("KeyHistoryAudit",{path: "KeyHistory/:key_id"});//NO I18N
           this.route("AddKeysGroup",{path:"addKeysGroup/:kgid"});//NO I18N
           this.route("AddUsersGroup",{path:"addUsersGroup/:ugid"});//NO I18N
           this.route("KeysGroupKeys",{path:"keysGroupKeys/:kgid"});//No I18N
            this.route('LandingServerConfig'); //No I18N
           this.route('LandingServerAssociation',{path: "landingServerAssociation/:lsid"}); //No I18N
       
    });
   this.resource("Tool", function(){//No I18N
       this.route('CSR');//No I18N
       this.route('Certificate');//No I18N
       this.route('SSLConvertor');//No I18N
       this.route('SSLVulnerabilityScanner');//No I18N
   });
   this.resource("Report",function(){ //No I18N
       this.route('All');//No I18N     
       this.route('PrivatekeyReport',{path: "privatekeyreport"});//No I18N
       this.route('KeyDeplotment',{path: "keydeployment"});//No I18N     
       this.route('UserAuditReport',{path: "userauditreport"});//No I18N     
       this.route('KeyRotationReport',{path: "keyrotationreport"});//No I18N
       this.route('ServerAccessAudit',{path: "serveraccessauditreport"});//No I18N
       this.route('SSLRequest',{path: "sslrequestresport"});//No I18N
       this.route('SSLCertificate',{path: "sslcertificatereport"});//No I18N
       this.route('InventoryReport',{path: "inventreport"});//No I18N
       this.route('UsersReport',{path:"usersreport"});//NO I18N
       this.route('SSHResourceReport',{path:"sshResourceReport"});//NO I18N
       this.route('SSLExpiry',{path:"sslExpiryReport"});//NO I18N
       this.route('KeyStoreReport',{path:"keystore"});//NO I18N
       this.route('AllKeysReport',{path:"allkeysreport"});//NO I18N
       this.route('WildcardCertificate',{path: "WildcardCertificate"});//No I18N
       this.route('AdUserCertificates',{path:"adUserCerts"});//NO I18N
       this.route('SHA1Certificate',{path: "SHA1Certificate"});//No I18N
        this.route('1024Certificate',{path: "1024ComplaintCerts"});//No I18N
        this.route('DeployedServers',{path: "DeployedServers"});//No I18N
        this.route('DeployedServersSyncStatus',{path: "DeployedServersSyncStatus"});//No I18N
         this.route('DeploymentReport',{path:"deploymentReport"});//NO I18N
       this.route('LetsEncryptRequests',{path:"ACMERequests/:id"});//NO I18N
       this.route('GoDaddyOrdersReport',{path:"godaddyOrders"});//NO I18N
       this.route('SSLStoreOrdersReport',{path:"sslStoreOrders"});//NO I18N
       this.route('LetsEncryptCertsReport',{path:"ACMECertsReport/:id"});//NO I18N
       this.route('SSLVulnerabilitiesReport');//NO I18N
       this.route('MSCARenewalReport');//NO I18N
       this.route('MDMCertificatesReport');//NO I18N
       this.route('MSCACertificatesReport');//NO I18N
       this.route('MSCACertificatesRevokeReport');//NO I18N
       this.route('SignReport');//NO I18N
       this.route('LandingServersReport');//NO I18N
       this.route('DigiCertOrdersReport',{path:"digiCertOrders"});//NO I18N
       this.route('GlobalSigntOrdersReport',{path:"globalsignOrders"});//NO I18N
       this.route('PGPKeysReport',{path:"pgpkeysreport"});//NO I18N
       this.route('AWSCertificatesReport');//NO I18N
       this.route('AWSCertificatesRequestReport');//NO I18N
       this.route('AzureCertificatesReport');//NO I18N
       this.route('AzureCertificateRequestReport');//NO I18N
       this.route('SectigoOrdersReport',{path:"sectigoOrders"});//NO I18N
       this.route('LoadBalancerCertificateReport'); //No I18N 
   });

   this.resource("Schedule",function(){ //No I18N
       this.route('All'); //No I18N
       this.route('Addschedule');  //No I18N
       this.route('Editschedule',{path:"Editschedule/:scheduleId"});  //No I18N
       this.route('AuditSchedule');//No I18N		
       //this.route('DetailedAuditScheduleDiscovery',{path:"DetailedAuditScheduleDiscovery/:scheduleAudit_id"});//No I18N
       //this.route('DetailedAuditScheduleKeyRotation',{path:"DetailedAuditScheduleKeyRotation/:scheduleAudit_id"});//No I18N
       //this.route('DetailedAuditScheduleReport',{path:"DetailedAuditScheduleReport/:scheduleAudit_id"});//No I18N
   });
   this.resource("EncryptionKeys",function(){ //No I18N
       this.route('StoreKeys'); //No I18N
       this.route('History',{path:"History/:encKeyId"});  //No I18N
       this.route("PGPKeys");//NO I18N       
       this.route("PGPKeyDetails",{path:"PGPKeyDetails/:keyId"});//NO I18N   
   });
    this.resource("Settings",function(){ //No I18N
       this.route('All'); //No I18N
       this.route('UserManagement'); //No I18N
       this.route('CreateUser'); //No I18N
       this.route('UpdateUser',{path: "UpdateUser/:user_id"}); //No I18N
       this.route('ChangePassword'); //No I18N
       this.route('Proxy'); //No I18N
       this.route('MailServer'); //No I18N
       this.route('ADAuth'); //No I18N
       this.route('ADGroupSyncList'); //No I18N
       this.route('Policy'); //No I18N
       this.resource('Notification',function(){//No I18N
       this.route('NotificationPolicy'); //No I18N
            this.route('NotificationAudit'); //No I18N
       }); 
       this.route('BackupDB'); //No I18N
       this.route('Rebrand'); //No I18N
       this.route('BackupScheduleAudit',{path:"backupScheduleAudit"}); //No I18N
       this.route('AboutLicense',{path:"aboutLicense"}); //No I18N
       this.route('ClientConfig',{path:"clientConfig"}); //No I18N
       this.route('ProductSSLSSHMode',{path:"productMode"}); //No I18N
	   this.route('apiKey'); //No I18N
           this.route('RadiusServer');//NO I18N
           this.route('LDAP');//NO I18N
           this.route('SAMLSSO');//NO I18N
           this.route('roles');//NO I18N
        this.route('SSLVulnerabilities');//NO I18N
        this.route("RejectedCertificates");//NO I18N
        this.route("SSLSettings");//NO I18N
        this.route("IISBinding");//NO I18N
        this.route('ServerCertificate');//NO I18N
        this.route('MSCASettings');//NO I18N       
        this.route('AutoSyncCheckSettings');//NO I18N       
        this.route('GlobalSSLMgmtSettings');//NO I18N       
        this.route('Ticketing');//NO I18N
        this.route('MDMIntegration');//NO I18N
       this.resource('SDP',function(){//NO I18N
           this.route('CMDB');//NO I18N
           this.route('SDPServer');//NO I18N
           this.route('IncidentSettings');//NO I18N
    });
       this.route('METracker');//NO I18N
       this.route('SNMP');//NO I18N
       this.route('Syslog');//NO I18N
       this.route('PurgeAudit');//NO I18N
       this.route('ExportSettings',{path:"exportsettings"});//NO I18N
       this.route('PIIData',{path:"piidata"});//NO I18N
       this.route('UnMappedMails',{path:"unmappedmails"});//NO I18N
       this.route('DomainExpiryData',{path:"domainexpirydata"});//NO I18N
       this.resource('CustomColumn');//NO I18N
       this.route('TFAuth');//NO I18N
    });

	this.resource("Audit",function(){ //No I18N
       this.route('All'); //No I18N
    });
});

App.IndexRoute = Ember.Route.extend({
    model: function (){
    },
    actions:{
        
					},
                    
	redirect: function() {
        
           var name = "current_url=";//No I18N
        var ca = document.cookie.split(';');
        var path = "";
        for (var i = 0; i < ca.length; i++) {
            var c = ca[i];
            while (c.charAt(0) == ' ') {
                c = c.substring(1);
					}
            if (c.indexOf(name) == 0)
            {
                path = c.substring(name.length, c.length);
            }
        }
        if (path.length>0)
        {
             if(path.indexOf('index.jsp#')!=-1)
            {
                location.href=path;
            }
            else
            {
                 if(userRole=="Administrator")
                {
                                dynamicLink();
                    
                }else{
                             this.transitionTo('SSHMgmt.SSH')   //NO I18N
                }
//                var ar = path.split(".");
//                var len = Object.keys(ar).length;
//                if (len > 2 && (ar[len-1]!='index'))
//                {
//                    path = ar[len - 2] + "." + ar[len - 1];
//                }
           //this.transitionTo(path);
            }
        } else
        {
            dynamicLink();
        }
	}
});


App.ApplicationRoute = Ember.Route.extend({
    isEnabled : false,
	notificationContent:"",
	redirectLink:"",
	iconStyle:{"INFO":"information.svg","WARNING":"warning.svg","IMPORTANT":"danger.svg"}, //No I18N
	bannerStyle:{"INFO":"info","WARNING":"warning","IMPORTANT":"danger"}, //No I18N
	creatorData:{},
	statusFlags:{"STATUS_VIEWED":1,"STATUS_CLOSED":2,"STATUS_REMIND":3}, //No I18N
    beforeModel: function(){
            App.FwPushNotificationComponent.iconStyle = {"INFO":"information.svg","WARNING":"warning.svg","IMPORTANT":"danger.svg"}; //No I18N
            App.FwPushNotificationComponent.bannerStyle = {"INFO":"info","WARNING":"warning","IMPORTANT":"danger"}; //No I18N
            App.FwPushNotificationComponent.statusFlags = {"STATUS_VIEWED":1,"STATUS_CLOSED":2,"STATUS_REMIND":3}; //No I18N
            var apiUrl = '/RestAPI/WC/PushNotification?mTCall=getPushNotification';//NO I18N
            var self = this;
            getSyncAjaxRequest(apiUrl,"","POST",function(response){
                if(response.NOTIFICATION_CONTENT){
                    App.FwPushNotificationComponent.creatorData=response;
                    App.FwPushNotificationComponent.isEnabled=true;
                    App.FwPushNotificationComponent.notificationContent=response.NOTIFICATION_CONTENT;
                    App.FwPushNotificationComponent.redirectLink=response.REDIRECT_URL;
                    App.FwPushNotificationComponent.iconSeverity=self.get('iconStyle')[response.SEVERITY];
                    App.FwPushNotificationComponent.bannerSeverity=self.get('bannerStyle')[response.SEVERITY];
                    App.FwPushNotificationComponent.push_notification_class_name='fw fw-top-bar-active'; //No I18N
            }});
            var promise=Ember.$.getJSON('/api/pki/settings/getClientSideViewList');//No I18N
            promise.then( function(jsonData) {
                        topview=jsonData;
                        });
                        return promise;
    },
    
    model: function(params) {
        App.ApplicationController.versionFolder=versionFolder;
        if(window.userRole!=="Administrator")//No I18N
        {
            App.ApplicationController.isAdmin=false; 
        }
        else
        {
            App.ApplicationController.isAdmin=true; 
        }
        App.ApplicationView.isLinuxInstallation=(((isLinux_pmp==null && window.isLinux.toLowerCase()==="linux")||(window.isLinux==null && isLinux_pmp===true ))); //No I18N
        if(demoUser==="yes")
        {
            App.ApplicationController.demo=true;
            App.ApplicationView.isLinuxInstallation=false;
        }
        else
        {
            App.ApplicationController.demo=false;
        }
        App.ApplicationController.isSSL=window.isSSL;
        App.ApplicationController.isSSH=window.isSSH;
        App.ApplicationController.isFULL=window.isFULL;
        App.ApplicationController.kmpStandAlone=kmpStandAlone;
        if(!App.ApplicationController.kmpStandAlone)
        {
        App.ApplicationController.isStandardEdition = isSSLOnlyLicensed;
    }
//        if(((isLinux_pmp==null && window.isLinux.toLowerCase()==="linux")||(window.isLinux==null && isLinux_pmp===true )) && !App.ApplicationController.demo)
//        {
//            App.ApplicationController.isWindows=false;
//        }else{
//             App.ApplicationController.isWindows=true;
//        }
    },
    setupController: function(controller,modal) {
        
  },
    actions: {
        openmodal: function(modalName, model) {
            if(model!=null)
            {
            this.controllerFor(modalName).set('model', model);//NO I18N
            }
            else
            {
                this.controllerFor(modalName);
            }
            this._super();
            return this.render(modalName, {
                into: 'application', //NO I18N
                outlet: 'modal'//NO I18N
            });
        },
        closeModal: function () {
            if($("#em_modal").val()!=undefined ){
                if($( "#em_modal" ).hasClass("ui-dialog-content") &&  $( "#em_modal" ).dialog("isOpen")){
                $( "#em_modal" ).dialog("close").dialog("destroy").remove();
                }else if($("#em_modal").val()==""){
                    $( "#em_modal" ).remove();
                }
            }else if($("#am_modal").val()!=undefined ){
                if($( "#am_modal" ).hasClass("ui-dialog-content") &&  $( "#am_modal" ).dialog("isOpen")){
                $( "#am_modal" ).dialog("close").dialog("destroy").remove();
                }else if($("#am_modal").val()==""){
                    $( "#am_modal" ).remove();
                }
            }else if($("#myModalPopup").val()!=undefined || $("#myModal").val()!=undefined  ||  $("#myModal1").val()!=undefined ){
                closeDialgIfOpen("#myModalPopup");//NO I18N
                closeDialgIfOpen("#myModal");//NO I18N
                closeDialgIfOpen("#myModal1");//NO I18N
            }
            //For Loading Bar hide
            NProgress.done();
          return this.disconnectOutlet({
                outlet: 'modal', //NO I18N
            parentView: 'application'//NO I18N
          });
        }, closeConfirmation: function () {
           if($("#myModalPopup").val()!=undefined || $("#myModal").val()!=undefined  ||  $("#myModal1").val()!=undefined ){
                closeDialgIfOpen("#myModalPopup");//NO I18N
                closeDialgIfOpen("#myModal");//NO I18N
                closeDialgIfOpen("#myModal1");//NO I18N
            }
        },
        openMyModal: function(modalName, model) {
            if(model!=null)
            {
            this.controllerFor(modalName).set('model', model);//NO I18N
        }
            else
            {
                this.controllerFor(modalName);
    }
            this._super();
            return this.render(modalName, {
                into: 'application', //NO I18N
                outlet: 'mymodal'//NO I18N
});
        },
        closeMyModal: function () {
            if($("#am_modal").val()!=undefined ){
                if($( "#am_modal" ).hasClass("ui-dialog-content") &&  $( "#am_modal" ).dialog("isOpen")){
                $( "#am_modal" ).dialog("close").dialog("destroy").remove();
                }else if($("#am_modal").val()==""){
                    $( "#am_modal" ).remove();
                }
            }else if($("#myModalPopup").val()!=undefined || $("#myModal").val()!=undefined  ||  $("#myModal1").val()!=undefined ){
                closeDialgIfOpen("#myModalPopup");//NO I18N
                closeDialgIfOpen("#myModal");//NO I18N
                closeDialgIfOpen("#myModal1");//NO I18N
            }
            //For Loading Bar hide
            NProgress.done();
          return this.disconnectOutlet({
                outlet: 'mymodal', //NO I18N
            parentView: 'application'//NO I18N
          });
        }
    }
});

App.EmpSearchResultComponent = Ember.Component.extend({
    didInsertElement: function () {
        var self = this;
        var imgSrc = "/images/";//No I18N
        document.getElementById('fw-push-notification').className=App.FwPushNotificationComponent.push_notification_class_name;
        document.getElementById('bannerSeverity').className="fw-top-bar fw-top-bar-"+App.FwPushNotificationComponent.bannerSeverity+" center";
        document.getElementById('dropCheck').className="dropdown-menu pull-left";
        document.getElementById('iconSeverity').src = imgSrc+App.FwPushNotificationComponent.iconSeverity;
        if(App.FwPushNotificationComponent.redirectLink==""){
            document.getElementById('knowMore').style.display = "none";
        }
    }
});


App.FwPushNotificationComponent = Ember.Component.extend({
    isEnabled : false,
	notificationContent:"",
	redirectLink:"",
	iconStyle:{"INFO":"info","WARNING":"warning-md","IMPORTANT":"danger-md"}, //No I18N
	bannerStyle:{"INFO":"info","WARNING":"warning","IMPORTANT":"danger"}, //No I18N
	creatorData:{},
	statusFlags:{"STATUS_VIEWED":1,"STATUS_CLOSED":2,"STATUS_REMIND":3}, //No I18N
});


/* Application Controller */
App.ApplicationController = Ember.Controller.extend({
    showLogin: false, //No I18N
    userName: "", //No I18N
    userRole: "",//No I18N
    isAdmin:true,//No I18N
     demo:false,
    res_id:"",
    isSSL:false,
    isSSH:false,
    isFULL:false,
    isWindows:true,
    kmpStandAlone:true,
    versionFolder:"",
    topViews:{},
    viewMenus:{},
    topurl:"",
    getBack:"",
    actions: {
        opendialog: function(modalName,model) {
            this.send('openmodal',modalName);//No I18N
        },
        toggleNotifierView : function(state)
		{
			var self = this;
			if(state == 'close')
			{
				Ember.$("#fw-push-notification").removeClass("fw-top-bar-active");
				Ember.$("#fw-push-notification").addClass("fw-top-bar-minimized");
			}
			else if(state == 'open')
			{
				Ember.$("#fw-push-notification").removeClass("fw-top-bar-minimized");
				Ember.$("#fw-push-notification").addClass("fw-top-bar-active");
			}
		},
        maximise: function() 
	    {
            var self = this;
            //Show Popup
            Ember.$(document).on("click",".fw-top-bar-minimized  .fw-top-bar",function(e){
                if(e.target.className.indexOf("fw-top-bar")!=-1){
                    self.send('toggleNotifierView','open'); //No I18N
                }
            });
	    },
        remindLater : function(statusFlag)
		{
			if(statusFlag == App.FwPushNotificationComponent.statusFlags.STATUS_VIEWED)
			{
				window.open(App.FwPushNotificationComponent.redirectLink);
			}
			this.send('closeNotification',statusFlag);// No I18N
		},
        closeNotification : function(statusFlag)
		{	
			var params={};
			params.NOTIFICATION_ID = App.FwPushNotificationComponent.creatorData.NOTIFICATION_ID;
			params.STATUS_FLAG = statusFlag;
			params.SEVERITY =App.FwPushNotificationComponent.creatorData.SEVERITY;
			var apiUrl = '/RestAPI/WC/PushNotification?mTCall=updateNotificationViewStatus';//NO I18N
            $.ajax({
                url:apiUrl,
                data:params,
                method:"POST" //NO I18N
            });
			if(params.SEVERITY != 'IMPORTANT' || params.STATUS_FLAG !=App.FwPushNotificationComponent.statusFlags.STATUS_VIEWED)
			{
				App.FwPushNotificationComponent.isEnabled = false;
                location.reload(true);
			}
		},
        openmydialog: function(modalName,model) {
            this.send('openMyModal',modalName);//No I18N
        },
                decideURL: function() {
            var keys = Object.keys(topview);
            if (keys.indexOf('Dashboard')>-1)
            {
                dynamicLink();
                App.ApplicationController.topurl = "#/Dashboard/GetStart";
            } else if (keys.indexOf('Discovery')>-1)
            {
                decideDiscoveryURL();
            } else if (keys.indexOf('SSH') >-1)
            {
                decideSSHURL();
            }
//            else if(keys.indexOf('PGP')>-1)
//            {
//                App.ApplicationController.topurl = "#/PGP/PGPKeys";//NO I18N
//                this.transitionTo('PGP.PGPKeys');//No I18N
//            }
            else if (keys.indexOf('SSL')>-1)
            {
                decideSSLURL();
            } else if (keys.indexOf('EncryptionKeys')>-1)
            {
                App.ApplicationController.topurl = "#/EncryptionKeys/StoreKeys";//NO I18N
                this.transitionTo('EncryptionKeys.StoreKeys');//No I18N
            } else if (keys.indexOf('Audit')>-1)
            {
                App.ApplicationController.topurl = "#/Audit/All";
                this.transitionTo('Audit.All');//No I18N
            } else if (keys.indexOf('Reports')>-1)
            {
                App.ApplicationController.topurl = "#/Report/All";
                this.transitionTo('Report.All');//No I18N
            } else if (keys.indexOf('Schedule')>-1)
            {
                App.ApplicationController.topurl = "#/Schedule/All";
                this.transitionTo('Schedule.All');//No I18N
            } else if (keys.indexOf('Settings')>-1)
            {
                decideSettingsURL();
        }
    },
        decideSSHURL: function ()
        {
            var availableTopViews = topview.SSH;
            if (availableTopViews.indexOf("SSH_Servers") > -1)
            {
                App.ApplicationController.topurl = "#/SSHMgmt/SSH";//No I18N
                this.transitionTo('SSHMgmt.SSH');
            } else if (availableTopViews.indexOf("SSH_Keys") > -1)
            {
                App.ApplicationController.topurl = "#/SSHMgmt/Keys";//No I18N
                this.transitionTo('SSHMgmt.Keys');
            } else if (availableTopViews.indexOf("SSH_Users") > -1)
            {
                App.ApplicationController.topurl = "#/SSHMgmt/AllUsers";//No I18N
                this.transitionTo('SSHMgmt.AllUsers');
            } else if (availableTopViews.indexOf("Discovered_Keys") > -1)
            {
                App.ApplicationController.topurl = "#/SSHMgmt/discoveredKeys";//No I18N
                this.transitionTo('SSHMgmt.discoveredKeys');
            } else if (availableTopViews.indexOf("Landing_Server") > -1)
            {
                App.ApplicationController.topurl = "#/SSHMgmt/LandingServerConfig";//No I18N
                this.transitionTo('SSHMgmt.LandingServerConfig');//No I18N
            }
        },
        
        decideSSLURL: function ()
        {
            var availableTopViews = topview.SSL;
            if (availableTopViews.indexOf("Certificates") > -1)
            {
                App.ApplicationController.topurl = "#/SSLMgmt/SSL";//No I18N
                this.transitionTo('SSLMgmt.SSL');//No I18N
            } else if (availableTopViews.indexOf("CreateCSR") > -1)
            {
                App.ApplicationController.topurl = "#/SSLMgmt/CreateCertificateList";//No I18N
                this.transitionTo('SSLMgmt.CreateCertificateList');//No I18N
            } else if (availableTopViews.indexOf("CertificateRequests") > -1)
            {
                App.ApplicationController.topurl = "#/SSLMgmt/Request/List";//No I18N
                this.transitionTo('Request.List');//No I18N
            } else if (availableTopViews.indexOf("LetsEncrypt") > -1)
            {
                //lets encrypt acmeserverid is appended to the url
                App.ApplicationController.topurl = "#/SSLMgmt/ACMERequestList/"+Object.keys(App.RequestCertController.acmeServers)[0];//No I18N
                this.transitionTo('SSLMgmt.LetsEncryptRequestList');//No I18N
            }
        },
    
    decideSettingsURL: function ()
    {
        var availableTopViews = topview.Settings;
        if (availableTopViews.indexOf("UserManagement") > -1)
        {
            App.ApplicationController.topurl = "#/Settings/UserManagement";
            this.transitionTo('Settings.UserManagement');
        } else if (availableTopViews.indexOf("ActiveDirectory") > -1)
        {
            App.ApplicationController.topurl = "#/Settings/ADAuth";
            this.transitionTo('Settings.ADAuth');
        } else if (availableTopViews.indexOf("Radius") > -1)
        {
            App.ApplicationController.topurl = "#/Settings/RadiusServer";
            this.transitionTo('Settings.RadiusServer');
        } else if (availableTopViews.indexOf("MailServer") > -1)
        {
            App.ApplicationController.topurl = "#/Settings/MailServer";
            this.transitionTo('Settings.MailServer');
        } else if (availableTopViews.indexOf("ProxyServer") > -1)
        {
            App.ApplicationController.topurl = "#/Settings/Proxy";
            this.transitionTo('Settings.Proxy');
        } else if (availableTopViews.indexOf("ChangePassword") > -1)
        {
            App.ApplicationController.topurl = "#/Settings/ChangePassword";
            this.transitionTo('Settings.ChangePassword');
        } else if (availableTopViews.indexOf("PolicyConfiguration") > -1)
        {
            App.ApplicationController.topurl = "#/Settings/Policy";
            this.transitionTo('Settings.Policy');
        } else if (availableTopViews.indexOf("Notification") > -1)
        {
            App.ApplicationController.topurl = "#/Settings/NotificationPolicy";
            this.transitionTo('Settings.NotificationPolicy');
        } else if (availableTopViews.indexOf("DBBackup") > -1)
        {
            App.ApplicationController.topurl = "#/Settings/BackupDB";
            this.transitionTo('Settings.BackupDB');
        } else if (availableTopViews.indexOf("DashboardSettings") > -1)
        {
            App.ApplicationController.topurl = "#/Settings/clientConfig";
            this.transitionTo('Settings.clientConfig');
        } else if (availableTopViews.indexOf("ApiKey") > -1)
        {
            App.ApplicationController.topurl = "#/Settings/apiKey";
            this.transitionTo('Settings.apiKey');
        } else if (availableTopViews.indexOf("UserManagement") > -1)
        {
            App.ApplicationController.topurl = "#/Settings/roles";
            this.transitionTo('Settings.roles');
        }
    },
    decideDiscoveryURL: function ()
    {
        var availableTopViews = topview.Discovery;
        if (availableTopViews.indexOf("Discover_SSH") > -1)
        {
            App.ApplicationController.topurl = "#/Discovery/SSH";
            this.transitionTo('Discovery.SSH');
        } else if (availableTopViews.indexOf("Discover_SSL") > -1)
        {
            App.ApplicationController.topurl = "#/Discovery/SSL";
            this.transitionTo('Discovery.SSL');
        } else if (availableTopViews.indexOf("AD_USER_Certificate") > -1)
        {
            App.ApplicationController.topurl = "#/Discovery/AD";
            this.transitionTo('Discovery.AD');
        } else if (availableTopViews.indexOf("MS_Certificate_Store") > -1)
        {
            App.ApplicationController.topurl = "#/Discovery/certStore";
            this.transitionTo('Discovery.certStore');
        }
    },
    
    },
    currentPathChanged: function () 
    {
        var myDiv=document.getElementById('scroll');//NO I18N
        if(myDiv!==null)
        {
            myDiv.scrollIntoView();
        }
        //For Loading Bar hide
        NProgress.done();
        return this.send('closeModal');//NO I18N
    }.observes('currentPath'), //No I18N
    onPageChange:function(){
        var path = this.get('currentPath');
        window.cur_path=path;
        document.cookie ='current_url=' + path;//No I18N
        sideMenuActive(path);
        //For Loading Bar hide
        NProgress.done();
    }.observes('currentPath') //No I18N
}); //No I18N


function sideMenuActive(path)
{
        if(document.getElementById("dashboard")!==null)
        {
                document.getElementById("settings").className="";
            document.getElementById("dashboard").className="";
                document.getElementById("discovery").className="";
                document.getElementById("ssl_mng").className="";
                document.getElementById("ssh_mng").className="";
                document.getElementById("report").className="";
                document.getElementById("schedule").className="";
                document.getElementById("auditList").className="";
            document.getElementById("enc_keys").className="";
            document.getElementById("tools").className="";
            //document.getElementById("pgp_mng").className="";
//          document.getElementById("inventory").className="";
            if(path.indexOf('Report')!=-1)
            {
                document.getElementById("report").className="sideMenuActive";
            }
//            else if(path.indexOf("PGP")!=-1)
//            {
//                document.getElementById("pgp_mng").className="sideMenuActive";
//            }
            else if(path.indexOf('Dashboard')!=-1)
            {

                document.getElementById("dashboard").className="sideMenuActive";
            }
            else if(path.indexOf('Discovery')!=-1)
            {
                document.getElementById("discovery").className="sideMenuActive";
            }
            else if(path.indexOf('Settings')!=-1)
            {
                document.getElementById("settings").className="sideMenuActive";
            }
            else if(path.indexOf('SSLMgmt')!=-1 || path.indexOf('LETSMgmt')!=-1 || path.indexOf('SSLStoreMgmt')!=-1 || path.indexOf('DigiCertMgmt')!=-1)
            {
                document.getElementById("ssl_mng").className="sideMenuActive";
            }
            else if(path.indexOf('SSHMgmt')!=-1)
            {
                document.getElementById("ssh_mng").className="sideMenuActive";
            }
            else if(path.indexOf('Schedule')!=-1)
            {
                document.getElementById("schedule").className="sideMenuActive";
            }
            else if(path.indexOf('Audit')!=-1)
            {
                document.getElementById("auditList").className="sideMenuActive";
            }
            else if(path.indexOf('EncryptionKeys')!=-1)
            {
                document.getElementById("enc_keys").className="sideMenuActive";
            }
            else if(path.indexOf('Tool')!==-1)
            {
                document.getElementById("tools").className="sideMenuActive";
        }
}
}

$(document).ready(function(){
    //DisplaySessionTimeout();
    //For Browse button
    /*$('.btn-file :file').on('fileselect', function(event, numFiles, label) {
        
        var input = $(this).parents('.input-group').find(':text'),//NO I18N
            log = numFiles > 1 ? numFiles + ' files selected' : label;//NO I18N
        
        if( input.length ) 
        {
            input.val(log);
        }        
    });*/
    

    //For SideMenu ToolTip
    //$('.km-tooltip').popover({trigger:'hover',animation: 'false',delay: { show: 100, hide: 1 }});
    
    //Nprogress Bar
    $(document).ajaxStart(function () {
        NProgress.configure({//No I18N
        showSpinner: false});
        NProgress.start();
        });
    $(document).ajaxStop(function () {
        NProgress.done();
    });

});


function Tip(tooltipContent,ele,position){
	if(tooltipContent && tooltipContent.trim()!="")
	{
		
		if(! jQuery(ele).hasClass("tooltipstered")){
			if(position==undefined){
				position='bottom';//NO I18N
			}
			jQuery(ele).tooltipster({
				content : tooltipContent,
				position: position,
				maxWidth: '300',//NO I18N
				trigger: 'custom'//NO I18N
			});
			jQuery(ele).tooltipster('show');//NO I18N
		}
	}
	
}
function UnTip(ele){
	if(jQuery(ele).hasClass("tooltipstered")){
		jQuery(ele).tooltipster('destroy');//NO I18N
	}
}


function isPasswordValid(password)
{
    var minMaxLength = /^[\s\S]{8,}$/,
        upper = /[A-Z]/,
        lower = /[a-z]/,
        number = /[0-9]/,
        special = /[ !"#$%&'()*+,\-./:;<=>?@[\\\]^_`{|}~]/;
    if((minMaxLength.test(password) &&
        upper.test(password) &&
        lower.test(password) &&
        number.test(password) &&
        special.test(password)))
    {
        return true;
    }
    return false;
}
